Index: arch/sparc64/lib/U3copy_from_user.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/U3copy_from_user.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/U3copy_from_user.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/U3copy_from_user.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: U3copy_from_user.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: U3copy_from_user.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * U3memcpy.S: UltraSparc-III optimized copy from userspace.
  *
  * Copyright (C) 1999, 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/U3copy_in_user.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/U3copy_in_user.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/U3copy_in_user.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/U3copy_in_user.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: U3copy_in_user.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: U3copy_in_user.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * U3memcpy.S: UltraSparc-III optimized copy within userspace.
  *
  * Copyright (C) 1999, 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/U3copy_to_user.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/U3copy_to_user.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/U3copy_to_user.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/U3copy_to_user.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: U3copy_to_user.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: U3copy_to_user.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * U3memcpy.S: UltraSparc-III optimized copy to userspace.
  *
  * Copyright (C) 1999, 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/U3memcpy.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/U3memcpy.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/U3memcpy.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/U3memcpy.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: U3memcpy.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: U3memcpy.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * U3memcpy.S: UltraSparc-III optimized memcpy.
  *
  * Copyright (C) 1999, 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/VIS.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VIS.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VIS.h	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VIS.h	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VIS.h,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VIS.h,v 1.2 2004/08/04 01:26:17 joff Exp $
  * VIS.h: High speed copy/clear operations utilizing the UltraSparc
  *        Visual Instruction Set.
  *
Index: arch/sparc64/lib/VISbzero.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VISbzero.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VISbzero.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VISbzero.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VISbzero.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VISbzero.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * VISbzero.S: High speed clear operations utilizing the UltraSparc
  *        Visual Instruction Set.
  *
Index: arch/sparc64/lib/VIScopy.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VIScopy.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VIScopy.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VIScopy.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VIScopy.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VIScopy.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * VIScopy.S: High speed copy operations utilizing the UltraSparc
  *            Visual Instruction Set.
  *
@@ -120,7 +120,6 @@
 #define EXVIS2(x,y) EXVISN(x,y,2)
 #define EXVIS3(x,y) EXVISN(x,y,3)
 #define EXVIS4(x,y) EXVISN(x,y,4)
-#define EXVIS5(x,y) EXVISN(x,y,5)
 
 #define FREG_FROB(f1, f2, f3, f4, f5, f6, f7, f8, f9)		\
 	faligndata		%f1, %f2, %f48;			\
@@ -135,7 +134,7 @@
 #define MAIN_LOOP_CHUNK(src, dest, fdest, fsrc, len, jmptgt)	\
 	EXVIS(LDBLK		[%src] ASIBLK, %fdest);		\
 	ASI_SETDST_BLK						\
-	EXVIS2(STBLK		%fsrc, [%dest] ASIBLK);		\
+	EXVIS(STBLK		%fsrc, [%dest] ASIBLK);		\
 	add			%src, 0x40, %src;		\
 	subcc			%len, 0x40, %len;		\
 	be,pn			%xcc, jmptgt;			\
@@ -156,14 +155,14 @@
 #ifdef __KERNEL__
 #define STORE_JUMP(dest, fsrc, target)				\
 	srl			asi_dest, 3, %g5;		\
-	EXVIS3(STBLK		%fsrc, [%dest] ASIBLK);		\
+	EXVIS2(STBLK		%fsrc, [%dest] ASIBLK);		\
 	xor		       asi_dest, ASI_BLK_XOR1, asi_dest;\
 	add			%dest, 0x40, %dest;		\
 	xor			asi_dest, %g5, asi_dest;	\
 	ba,pt			%xcc, target;
 #else
 #define STORE_JUMP(dest, fsrc, target)				\
-	EXVIS3(STBLK		%fsrc, [%dest] ASIBLK);		\
+	EXVIS2(STBLK		%fsrc, [%dest] ASIBLK);		\
 	add			%dest, 0x40, %dest;		\
 	ba,pt			%xcc, target;
 #endif
@@ -182,7 +181,7 @@
 	subcc			%left, 8, %left;		\
 	bl,pn			%xcc, vis_out;			\
 	 faligndata		%f0, %f1, %f48;			\
-	EXVIS4(STDF		%f48, [%dest] ASINORMAL);	\
+	EXVIS3(STDF		%f48, [%dest] ASINORMAL);	\
 	add			%dest, 8, %dest;
 
 #define UNEVEN_VISCHUNK_LAST(dest, f0, f1, left)		\
@@ -675,21 +674,21 @@
 	xor		asi_src, %g5, asi_src			! IEU0	Group
 #endif
 vis_slk:ASI_SETSRC_NOBLK					! LSU	Group
-	EXVIS4(LDDF	[%o1] ASINORMAL, %f2)			! Load	Group
+	EXVIS3(LDDF	[%o1] ASINORMAL, %f2)			! Load	Group
 	add		%o1, 8, %o1				! IEU0
 	subcc		%g3, 8, %g3				! IEU1
 	ASI_SETDST_NOBLK					! LSU	Group
 	faligndata	%f0, %f2, %f8				! GRU	Group
-	EXVIS5(STDF	%f8, [%o0] ASINORMAL)			! Store
+	EXVIS4(STDF	%f8, [%o0] ASINORMAL)			! Store
 	bl,pn		%xcc, vis_out_slp			! CTI
 	 add		%o0, 8, %o0				! IEU0	Group
 	ASI_SETSRC_NOBLK					! LSU	Group
-	EXVIS4(LDDF	[%o1] ASINORMAL, %f0)			! Load	Group
+	EXVIS3(LDDF	[%o1] ASINORMAL, %f0)			! Load	Group
 	add		%o1, 8, %o1				! IEU0
 	subcc		%g3, 8, %g3				! IEU1
 	ASI_SETDST_NOBLK					! LSU	Group
 	faligndata	%f2, %f0, %f8				! GRU	Group
-	EXVIS5(STDF	%f8, [%o0] ASINORMAL)			! Store
+	EXVIS4(STDF	%f8, [%o0] ASINORMAL)			! Store
 	bge,pt		%xcc, vis_slk				! CTI
 	 add		%o0, 8, %o0				! IEU0	Group
 vis_out_slp:
@@ -1138,20 +1137,18 @@
 		sub		%g7, %g2, %g7
 		ba,pt		%xcc, VIScopyfixup_ret
 		 add		%g7, %o2, %o1
-VIScopyfixup_vis3:
-		sub		%o2, 0x80, %o2
 VIScopyfixup_vis2:
-		add		%o2, 0x40, %o2
+		sub		%o2, 0x40, %o2
 VIScopyfixup_vis0:
 		add		%o2, 0x80, %o2
 VIScopyfixup_vis1:
 		add		%g7, %g3, %g7
 		ba,pt		%xcc, VIScopyfixup_ret
 		 add		%o2, %g7, %o1
-VIScopyfixup_vis5:
-		add		%g3, 8, %g3
 VIScopyfixup_vis4:
 		add		%g3, 8, %g3
+VIScopyfixup_vis3:
+		add		%g3, 8, %g3
 		ba,pt		%xcc, VIScopyfixup_ret
 		 add		%o2, %g3, %o1
 #endif
Index: arch/sparc64/lib/VIScsum.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VIScsum.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VIScsum.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VIScsum.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VIScsum.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VIScsum.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * VIScsum.S: High bandwidth IP checksumming utilizing the UltraSparc
  *            Visual Instruction Set.
  *
Index: arch/sparc64/lib/VIScsumcopy.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VIScsumcopy.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VIScsumcopy.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VIScsumcopy.S	4 Aug 2004 01:26:17 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VIScsumcopy.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VIScsumcopy.S,v 1.2 2004/08/04 01:26:17 joff Exp $
  * VIScsumcopy.S: High bandwidth IP checksumming with simultaneous
  *            copying utilizing the UltraSparc Visual Instruction Set.
  *
Index: arch/sparc64/lib/VIScsumcopyusr.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VIScsumcopyusr.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VIScsumcopyusr.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VIScsumcopyusr.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VIScsumcopyusr.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VIScsumcopyusr.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * VIScsumcopyusr.S: High bandwidth IP checksumming with simultaneous
  *                   copying utilizing the UltraSparc Visual Instruction Set.
  *
Index: arch/sparc64/lib/VISmemset.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VISmemset.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VISmemset.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VISmemset.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VISmemset.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VISmemset.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * VISmemset.S: High speed memset operations utilizing the UltraSparc
  *        Visual Instruction Set.
  *
Index: arch/sparc64/lib/VISsave.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/VISsave.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/VISsave.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/VISsave.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: VISsave.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: VISsave.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * VISsave.S: Code for saving FPU register state for
  *            VIS routines. One should not call this directly,
  *            but use macros provided in <asm/visasm.h>.
Index: arch/sparc64/lib/atomic.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/atomic.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/atomic.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/atomic.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: atomic.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: atomic.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * atomic.S: These things are too big to do inline.
  *
  * Copyright (C) 1999 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/bitops.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/bitops.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/bitops.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/bitops.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: bitops.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: bitops.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * bitops.S: Sparc64 atomic bit operations.
  *
  * Copyright (C) 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/blockops.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/blockops.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/blockops.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/blockops.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: blockops.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: blockops.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * blockops.S: UltraSparc block zero optimized routines.
  *
  * Copyright (C) 1996, 1998, 1999, 2000 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/debuglocks.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/debuglocks.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/debuglocks.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/debuglocks.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: debuglocks.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: debuglocks.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * debuglocks.c: Debugging versions of SMP locking primitives.
  *
  * Copyright (C) 1998 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/dec_and_lock.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/dec_and_lock.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/dec_and_lock.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/dec_and_lock.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: dec_and_lock.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: dec_and_lock.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * dec_and_lock.S: Sparc64 version of "atomic_dec_and_lock()"
  *                 using cas and ldstub instructions.
  *
Index: arch/sparc64/lib/memcmp.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/memcmp.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/memcmp.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/memcmp.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: memcmp.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: memcmp.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * Sparc64 optimized memcmp code.
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/lib/memscan.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/memscan.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/memscan.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/memscan.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: memscan.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: memscan.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * memscan.S: Optimized memscan for Sparc64.
  *
  * Copyright (C) 1997,1998 Jakub Jelinek (jj@ultra.linux.cz)
Index: arch/sparc64/lib/rwlock.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/rwlock.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/rwlock.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/rwlock.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: rwlock.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: rwlock.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * rwlocks.S: These things are too big to do inline.
  *
  * Copyright (C) 1999 David S. Miller (davem@redhat.com)
Index: arch/sparc64/lib/strncmp.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/strncmp.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/strncmp.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/strncmp.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: strncmp.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: strncmp.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * Sparc64 optimized strncmp code.
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/lib/strncpy_from_user.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/lib/strncpy_from_user.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/lib/strncpy_from_user.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/lib/strncpy_from_user.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: strncpy_from_user.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: strncpy_from_user.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * strncpy_from_user.S: Sparc64 strncpy from userspace.
  *
  *  Copyright (C) 1997, 1999 Jakub Jelinek (jj@ultra.linux.cz)
Index: arch/sparc64/math-emu/math.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/math-emu/math.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/math-emu/math.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/math-emu/math.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: math.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: math.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * arch/sparc64/math-emu/math.c
  *
  * Copyright (C) 1997,1999 Jakub Jelinek (jj@ultra.linux.cz)
Index: arch/sparc64/math-emu/sfp-util.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/math-emu/sfp-util.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/math-emu/sfp-util.h	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/math-emu/sfp-util.h	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: sfp-util.h,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: sfp-util.h,v 1.2 2004/08/04 01:26:18 joff Exp $
  * arch/sparc64/math-emu/sfp-util.h
  *
  * Copyright (C) 1999 Jakub Jelinek (jj@ultra.linux.cz)
Index: arch/sparc64/mm/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/Makefile	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/Makefile	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:18 joff Exp $
 # Makefile for the linux Sparc64-specific parts of the memory manager.
 #
 
Index: arch/sparc64/mm/fault.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/fault.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/fault.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/fault.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: fault.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: fault.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * arch/sparc64/mm/fault.c: Page fault handlers for the 64-bit Sparc.
  *
  * Copyright (C) 1996 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc64/mm/generic.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/generic.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/generic.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/generic.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: generic.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: generic.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * generic.c: Generic Sparc mm routines that are not dependent upon
  *            MMU type but are Sparc specific.
  *
Index: arch/sparc64/mm/init.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/init.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/init.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/init.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/*  $Id: init.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/*  $Id: init.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  *  arch/sparc64/mm/init.c
  *
  *  Copyright (C) 1996-1999 David S. Miller (davem@caip.rutgers.edu)
@@ -34,6 +34,7 @@
 #include <asm/starfire.h>
 #include <asm/tlb.h>
 #include <asm/spitfire.h>
+#include <asm/sections.h>
 
 mmu_gather_t mmu_gathers[NR_CPUS];
 
@@ -44,9 +45,16 @@
 unsigned long *sparc64_valid_addr_bitmap;
 
 /* Ugly, but necessary... -DaveM */
-unsigned long phys_base;
+unsigned long phys_base, kern_base, kern_size;
 
-enum ultra_tlb_layout tlb_type = spitfire;
+/* This is even uglier. We have a problem where the kernel may not be
+ * located at phys_base. However, initial __alloc_bootmem() calls need to
+ * be adjusted to be within the 4-8Megs that the kernel is mapped to, else
+ * those page mappings wont work. Things are ok after inherit_prom_mappings
+ * is called though. Dave says he'll clean this up some other time.
+ * -- BenC
+ */
+static unsigned long bootmap_base;
 
 /* get_new_mmu_context() uses "cache + 1".  */
 spinlock_t ctx_alloc_lock = SPIN_LOCK_UNLOCKED;
@@ -54,9 +62,6 @@
 #define CTX_BMAP_SLOTS (1UL << (CTX_VERSION_SHIFT - 6))
 unsigned long mmu_context_bmap[CTX_BMAP_SLOTS];
 
-/* References to section boundaries */
-extern char __init_begin, __init_end, _start, _end, etext, edata;
-
 /* Initial ramdisk setup */
 extern unsigned int sparc_ramdisk_image;
 extern unsigned int sparc_ramdisk_size;
@@ -346,7 +351,7 @@
 	n += 5 * sizeof(struct linux_prom_translation);
 	for (tsz = 1; tsz < n; tsz <<= 1)
 		/* empty */;
-	trans = __alloc_bootmem(tsz, SMP_CACHE_BYTES, 0UL);
+	trans = __alloc_bootmem(tsz, SMP_CACHE_BYTES, bootmap_base);
 	if (trans == NULL) {
 		prom_printf("inherit_prom_mappings: Cannot alloc translations.\n");
 		prom_halt();
@@ -366,7 +371,7 @@
 	 * in inherit_locked_prom_mappings()).
 	 */
 #define OBP_PMD_SIZE 2048
-	prompmd = __alloc_bootmem(OBP_PMD_SIZE, OBP_PMD_SIZE, 0UL);
+	prompmd = __alloc_bootmem(OBP_PMD_SIZE, OBP_PMD_SIZE, bootmap_base);
 	if (prompmd == NULL)
 		early_pgtable_allocfail("pmd");
 	memset(prompmd, 0, OBP_PMD_SIZE);
@@ -384,7 +389,7 @@
 				if (pmd_none(*pmdp)) {
 					ptep = __alloc_bootmem(BASE_PAGE_SIZE,
 							       BASE_PAGE_SIZE,
-							       0UL);
+							       bootmap_base);
 					if (ptep == NULL)
 						early_pgtable_allocfail("pte");
 					memset(ptep, 0, BASE_PAGE_SIZE);
@@ -1204,6 +1209,10 @@
 	unsigned long bootmap_pfn, bytes_avail, size;
 	int i;
 
+#ifdef CONFIG_DEBUG_BOOTMEM
+	prom_printf("bootmem_init: Scan sp_banks, ");
+#endif
+
 	bytes_avail = 0UL;
 	for (i = 0; sp_banks[i].num_bytes != 0; i++) {
 		end_of_phys_memory = sp_banks[i].base_addr +
@@ -1234,15 +1243,8 @@
 	 * image.  The kernel is hard mapped below PAGE_OFFSET in a
 	 * 4MB locked TLB translation.
 	 */
-	start_pfn  = PAGE_ALIGN((unsigned long) &_end) -
-		((unsigned long) KERNBASE);
+	start_pfn = PAGE_ALIGN(kern_base + kern_size) >> PAGE_SHIFT;
 
-	/* Adjust up to the physical address where the kernel begins. */
-	start_pfn += phys_base;
-
-	/* Now shift down to get the real physical page frame number. */
-	start_pfn >>= PAGE_SHIFT;
-	
 	bootmap_pfn = start_pfn;
 
 	end_pfn = end_of_phys_memory >> PAGE_SHIFT;
@@ -1270,19 +1272,33 @@
 	/* Initialize the boot-time allocator. */
 	max_pfn = max_low_pfn = end_pfn;
 	min_low_pfn = phys_base >> PAGE_SHIFT;
-	bootmap_size = init_bootmem_node(NODE_DATA(0), bootmap_pfn, phys_base>>PAGE_SHIFT, end_pfn);
+
+#ifdef CONFIG_DEBUG_BOOTMEM
+	prom_printf("init_bootmem(min[%lx], bootmap[%lx], max[%lx])\n",
+		    min_low_pfn, bootmap_pfn, max_low_pfn);
+#endif
+	bootmap_size = init_bootmem_node(NODE_DATA(0), bootmap_pfn, min_low_pfn, end_pfn);
+
+	bootmap_base = bootmap_pfn << PAGE_SHIFT;
 
 	/* Now register the available physical memory with the
 	 * allocator.
 	 */
-	for (i = 0; sp_banks[i].num_bytes != 0; i++)
-		free_bootmem(sp_banks[i].base_addr,
-			     sp_banks[i].num_bytes);
+	for (i = 0; sp_banks[i].num_bytes != 0; i++) {
+#ifdef CONFIG_DEBUG_BOOTMEM
+		prom_printf("free_bootmem(sp_banks:%d): base[%lx] size[%lx]\n",
+			    i, sp_banks[i].base_addr, sp_banks[i].num_bytes);
+#endif
+		free_bootmem(sp_banks[i].base_addr, sp_banks[i].num_bytes);
+	}
 
 #ifdef CONFIG_BLK_DEV_INITRD
 	if (initrd_start) {
 		size = initrd_end - initrd_start;
-
+#ifdef CONFIG_DEBUG_BOOTMEM
+		prom_printf("reserve_bootmem(initrd): base[%lx] size[%lx]\n",
+			    initrd_start, size);
+#endif
 		/* Resert the initrd image area. */
 		reserve_bootmem(initrd_start, size);
 		*pages_avail -= PAGE_ALIGN(size) >> PAGE_SHIFT;
@@ -1292,15 +1308,21 @@
 	}
 #endif
 	/* Reserve the kernel text/data/bss. */
-	size = (start_pfn << PAGE_SHIFT) - phys_base;
-	reserve_bootmem(phys_base, size);
-	*pages_avail -= PAGE_ALIGN(size) >> PAGE_SHIFT;
+#ifdef CONFIG_DEBUG_BOOTMEM
+	prom_printf("reserve_bootmem(kernel): base[%lx] size[%lx]\n", kern_base, kern_size);
+#endif
+	reserve_bootmem(kern_base, kern_size);
+	*pages_avail -= PAGE_ALIGN(kern_size) >> PAGE_SHIFT;
 
 	/* Reserve the bootmem map.   We do not account for it
 	 * in pages_avail because we will release that memory
 	 * in free_all_bootmem.
 	 */
 	size = bootmap_size;
+#ifdef CONFIG_DEBUG_BOOTMEM
+	prom_printf("reserve_bootmem(bootmap): base[%lx] size[%lx]\n",
+		    (bootmap_pfn << PAGE_SHIFT), size);
+#endif
 	reserve_bootmem((bootmap_pfn << PAGE_SHIFT), size);
 	*pages_avail -= PAGE_ALIGN(size) >> PAGE_SHIFT;
 
@@ -1319,7 +1341,7 @@
 	extern pmd_t swapper_pmd_dir[1024];
 	extern unsigned int sparc64_vpte_patchme1[1];
 	extern unsigned int sparc64_vpte_patchme2[1];
-	unsigned long alias_base = phys_base + PAGE_OFFSET;
+	unsigned long alias_base = kern_base + PAGE_OFFSET;
 	unsigned long second_alias_page = 0;
 	unsigned long pt, flags, end_pfn, pages_avail;
 	unsigned long shift = alias_base - ((unsigned long)KERNBASE);
@@ -1339,7 +1361,7 @@
 	 * if this were not true we wouldn't boot up to this point
 	 * anyways.
 	 */
-	pt  = phys_base | _PAGE_VALID | _PAGE_SZ4MB;
+	pt  = kern_base | _PAGE_VALID | _PAGE_SZ4MB;
 	pt |= _PAGE_CP | _PAGE_CV | _PAGE_P | _PAGE_L | _PAGE_W;
 	__save_and_cli(flags);
 	if (tlb_type == spitfire) {
@@ -1419,14 +1441,6 @@
 	pages_avail = 0;
 	last_valid_pfn = end_pfn = bootmem_init(&pages_avail);
 
-#ifdef CONFIG_SUN_SERIAL
-	/* This does not logically belong here, but we need to
-	 * call it at the moment we are able to use the bootmem
-	 * allocator.
-	 */
-	sun_serial_setup();
-#endif
-
 	/* Inherit non-locked OBP mappings. */
 	inherit_prom_mappings();
 	
@@ -1441,7 +1455,16 @@
 	}
 
 	inherit_locked_prom_mappings(1);
-	
+
+#ifdef CONFIG_SUN_SERIAL
+	/* This does not logically belong here, but we need to call it at
+	 * the moment we are able to use the bootmem allocator. This _has_
+	 * to be done after the prom_mappings above so since
+	 * __alloc_bootmem() doesn't work correctly until then.
+	 */
+	sun_serial_setup();
+#endif
+
 	/* We only created DTLB mapping of this stuff. */
 	spitfire_flush_dtlb_nucleus_page(alias_base);
 	if (second_alias_page)
@@ -1611,17 +1634,15 @@
 	i = last_valid_pfn >> ((22 - PAGE_SHIFT) + 6);
 	i += 1;
 	sparc64_valid_addr_bitmap = (unsigned long *)
-		__alloc_bootmem(i << 3, SMP_CACHE_BYTES, 0UL);
+		__alloc_bootmem(i << 3, SMP_CACHE_BYTES, bootmap_base);
 	if (sparc64_valid_addr_bitmap == NULL) {
 		prom_printf("mem_init: Cannot alloc valid_addr_bitmap.\n");
 		prom_halt();
 	}
 	memset(sparc64_valid_addr_bitmap, 0, i << 3);
 
-	addr = PAGE_OFFSET + phys_base;
-	last = PAGE_ALIGN((unsigned long)&_end) -
-		((unsigned long) KERNBASE);
-	last += PAGE_OFFSET + phys_base;
+	addr = PAGE_OFFSET + kern_base;
+	last = PAGE_ALIGN(kern_size) + addr;
 	while (addr < last) {
 		set_bit(__pa(addr) >> 22, sparc64_valid_addr_bitmap);
 		addr += PAGE_SIZE;
@@ -1632,6 +1653,9 @@
 	max_mapnr = last_valid_pfn - (phys_base >> PAGE_SHIFT);
 	high_memory = __va(last_valid_pfn << PAGE_SHIFT);
 
+#ifdef CONFIG_DEBUG_BOOTMEM
+	prom_printf("mem_init: Calling free_all_bootmem().\n");
+#endif
 	num_physpages = free_all_bootmem() - 1;
 
 	/*
@@ -1658,7 +1682,7 @@
 		/* Put empty_pg_dir on pgd_quicklist */
 		extern pgd_t empty_pg_dir[1024];
 		unsigned long addr = (unsigned long)empty_pg_dir;
-		unsigned long alias_base = phys_base + PAGE_OFFSET -
+		unsigned long alias_base = kern_base + PAGE_OFFSET -
 			(long)(KERNBASE);
 		
 		memset(empty_pg_dir, 0, sizeof(empty_pg_dir));
@@ -1693,7 +1717,7 @@
 		struct page *p;
 
 		page = (addr +
-			((unsigned long) __va(phys_base)) -
+			((unsigned long) __va(kern_base)) -
 			((unsigned long) KERNBASE));
 		p = virt_to_page(page);
 
Index: arch/sparc64/mm/modutil.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/modutil.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/modutil.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/modutil.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/*  $Id: modutil.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/*  $Id: modutil.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  *  arch/sparc64/mm/modutil.c
  *
  *  Copyright (C) 1997,1998 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
@@ -11,9 +11,9 @@
 #include <asm/uaccess.h>
 #include <asm/system.h>
 
-static struct vm_struct * modvmlist = NULL;
+static struct vm_struct *modvmlist = NULL;
 
-void module_unmap (void * addr)
+void __module_unmap(void *addr, int free_area_pages)
 {
 	struct vm_struct **p, *tmp;
 
@@ -26,7 +26,9 @@
 	for (p = &modvmlist ; (tmp = *p) ; p = &tmp->next) {
 		if (tmp->addr == addr) {
 			*p = tmp->next;
-			vmfree_area_pages(VMALLOC_VMADDR(tmp->addr), tmp->size);
+			if (free_area_pages)
+				vmfree_area_pages(VMALLOC_VMADDR(tmp->addr),
+						  tmp->size);
 			kfree(tmp);
 			return;
 		}
@@ -34,13 +36,19 @@
 	printk("Trying to unmap nonexistent module vm area (%p)\n", addr);
 }
 
-void * module_map (unsigned long size)
+void module_unmap(void *addr)
+{
+	__module_unmap(addr, 1);
+}
+
+void *module_map (unsigned long size)
 {
 	void * addr;
 	struct vm_struct **p, *tmp, *area;
 
 	size = PAGE_ALIGN(size);
-	if (!size || size > MODULES_LEN) return NULL;
+	if (!size || size > MODULES_LEN)
+		return NULL;
 		
 	addr = (void *) MODULES_VADDR;
 	for (p = &modvmlist; (tmp = *p) ; p = &tmp->next) {
@@ -48,17 +56,19 @@
 			break;
 		addr = (void *) (tmp->size + (unsigned long) tmp->addr);
 	}
-	if ((unsigned long) addr + size >= MODULES_END) return NULL;
+	if ((unsigned long) addr + size >= MODULES_END)
+		return NULL;
 	
 	area = (struct vm_struct *) kmalloc(sizeof(*area), GFP_KERNEL);
-	if (!area) return NULL;
+	if (!area)
+		return NULL;
 	area->size = size + PAGE_SIZE;
 	area->addr = addr;
 	area->next = *p;
 	*p = area;
 
 	if (vmalloc_area_pages(VMALLOC_VMADDR(addr), size, GFP_KERNEL, PAGE_KERNEL)) {
-		module_unmap(addr);
+		__module_unmap(addr, 0);
 		return NULL;
 	}
 	return addr;
Index: arch/sparc64/mm/ultra.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/mm/ultra.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/mm/ultra.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/mm/ultra.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ultra.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: ultra.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * ultra.S: Don't expand these all over the place...
  *
  * Copyright (C) 1997, 2000 David S. Miller (davem@redhat.com)
